diff --git a/roms/ipxe/src/util/fnrec.pl b/roms/ipxe/src/util/fnrec.pl
index 9a2b3d81f98e1d366b9bc0608bd9..cc7312b61a42ae85206983171e9c 100755
--- a/roms/ipxe/src/util/fnrec.pl
+++ b/roms/ipxe/src/util/fnrec.pl
@@ -14,7 +14,8 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
 
 =head1 NAME
 
diff --git a/roms/ipxe/src/util/geniso b/roms/ipxe/src/util/geniso
index 790e7171d593dcaa698cab87269e..48ea2f2aae08f9732a1ca3a33600 100755
--- a/roms/ipxe/src/util/geniso
+++ b/roms/ipxe/src/util/geniso
@@ -56,7 +56,7 @@ do
 	g=${g//[^a-z0-9]}.krn
 	case "$first" in
 	"")
-		echo DEFAULT $g
+		echo DEFAULT $b
 		;;
 	esac
 	first=$g
diff --git a/roms/ipxe/src/util/genkeymap.pl b/roms/ipxe/src/util/genkeymap.pl
index d556df27521e3146c4457fe98832..7a5024bf8e45f41b45d5a7aeb63f 100755
--- a/roms/ipxe/src/util/genkeymap.pl
+++ b/roms/ipxe/src/util/genkeymap.pl
@@ -14,7 +14,8 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
 
 =head1 NAME
 
@@ -124,8 +125,10 @@ sub keysym_to_ascii {
   return unless $keysym;
 
   # Sanity check
-  die "Unexpected keysym ".sprintf ( "0x%04x\n", $keysym )."\n"
-      if $keysym & 0xf000;
+  if ( $keysym & 0xf000 ) {
+    warn "Unexpected keysym ".sprintf ( "0x%04x", $keysym )."\n";
+    return;
+  }
 
   # Extract type and value
   my $type = ( $keysym >> 8 );
diff --git a/roms/ipxe/src/util/get-pci-ids b/roms/ipxe/src/util/get-pci-ids
index 6501a7f7c401f6483d60b9704b3b..424662212769878438b9c55a4ff9 100755
--- a/roms/ipxe/src/util/get-pci-ids
+++ b/roms/ipxe/src/util/get-pci-ids
@@ -16,7 +16,8 @@
 
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
 
 
 # Known bugs/limitations:
diff --git a/roms/ipxe/src/util/iccfix.c b/roms/ipxe/src/util/iccfix.c
index 8b555c5454e0a5f6e298ed37abb4..528bf4b26c09c6b39e949204e736 100644
--- a/roms/ipxe/src/util/iccfix.c
+++ b/roms/ipxe/src/util/iccfix.c
@@ -2,6 +2,7 @@
 #include <stddef.h>
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 #include <unistd.h>
 #include <fcntl.h>
 #include <errno.h>
@@ -49,7 +50,7 @@ static int ICCFIX ( void *elf ) {
 		     ( align >= ICC_ALIGN_HACK_FACTOR ) ) {
 			new_align = ( align / ICC_ALIGN_HACK_FACTOR );
 			shdr->sh_addralign = new_align;
-			dprintf ( "Section \"%s\": alignment %d->%d\n",
+			dprintf ( "Section \"%s\": alignment %ld->%ld\n",
 				  name, align, new_align );
 		}
 	}
diff --git a/roms/ipxe/src/util/licence.pl b/roms/ipxe/src/util/licence.pl
index c37685d3aa4d0cc02da1e7441b12..0e43c7b4c783cefce7e99aabc228 100755
--- a/roms/ipxe/src/util/licence.pl
+++ b/roms/ipxe/src/util/licence.pl
@@ -14,7 +14,8 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
 
 use strict;
 use warnings;
diff --git a/roms/ipxe/src/util/mergerom.pl b/roms/ipxe/src/util/mergerom.pl
index f9c52502d13de827ca6ee848e474..f5c1632b0ce22f0a6284a03fa118 100755
--- a/roms/ipxe/src/util/mergerom.pl
+++ b/roms/ipxe/src/util/mergerom.pl
@@ -14,7 +14,8 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
 
 use strict;
 use warnings;
@@ -43,9 +44,6 @@ my $offset = $baserom->length;
 
 foreach my $rom ( @roms ) {
 
-  # Update base length
-  $baserom->{length} += $rom->{length};
-
   # Merge initialisation entry point
   merge_entry_points ( $baserom->{init}, $rom->{init}, $offset );
 
@@ -84,15 +82,36 @@ foreach my $rom ( @roms ) {
     merge_entry_points ( $baserom_pnp->{bev}, $rom_pnp->{bev}, $offset );
   }
 
+  # Update iPXE header, if present
+  my $baserom_ipxe = $baserom->ipxe_header;
+  my $rom_ipxe = $rom->ipxe_header;
+  if ( $baserom_ipxe ) {
+
+    # Update shrunk length
+    $baserom_ipxe->{shrunk_length} = ( $baserom->{length} +
+				       ( $rom_ipxe ?
+					 $rom_ipxe->{shrunk_length} :
+					 $rom->{length} ) );
+
+    # Fix checksum
+    $baserom_ipxe->fix_checksum();
+  }
+
+  # Update base length
+  $baserom->{length} += $rom->{length};
+
   # Fix checksum for this ROM segment
   $rom->fix_checksum();
 
+  # Add this ROM to base ROM
+  my $data = substr ( $baserom->get(), 0, $baserom->length() );
+  $data .= $rom->get();
+  $data .= $baserom->next_image()->get() if $baserom->next_image();
+  $baserom->set ( $data );
+
   $offset += $rom->length;
 }
 
 $baserom->pnp_header->fix_checksum() if $baserom->pnp_header;
 $baserom->fix_checksum();
 $baserom->save ( "-" );
-foreach my $rom ( @roms ) {
-  $rom->save ( "-" );
-}
diff --git a/roms/ipxe/src/util/nrv2b.c b/roms/ipxe/src/util/nrv2b.c
index 6bac4cdda28dde04198f6a6f52b4..031f5d9cb4a2c2560fb0a5ed2d24 100644
--- a/roms/ipxe/src/util/nrv2b.c
+++ b/roms/ipxe/src/util/nrv2b.c
@@ -77,7 +77,7 @@ static __inline__ void Error(char *message)
 
 /* These will be a complete waste of time on a lo-endian */
 /* system, but it only gets done once so WTF. */
-static unsigned long i86ul_to_host(unsigned long ul)
+static unsigned long __attribute__ (( unused )) i86ul_to_host(unsigned long ul)
 {
 	unsigned long res = 0;
 	int i;
@@ -209,7 +209,7 @@ struct ucl_compress
 
 #define SWD_HSIZE	16384
 #define SWD_MAX_CHAIN	2048
-#define SWD_BEST_OFF    1
+#undef SWD_BEST_OFF
 
 #define HEAD3(b,p) \
     (((0x9f5f*(((((uint32_t)b[p]<<5)^b[p+1])<<5)^b[p+2]))>>5) & (SWD_HSIZE-1))
@@ -375,7 +375,6 @@ static
 int swd_init(struct ucl_swd *s, const uint8_t *dict, unsigned int dict_len)
 {
 	unsigned int i = 0;
-	int c = 0;
 
 	if (s->n == 0)
 		s->n = N;
@@ -439,7 +438,7 @@ static
 void swd_exit(struct ucl_swd *s)
 {
 	/* unused s */
-
+	( void ) s;
 }
 
 #define swd_pos2off(s,pos) \
diff --git a/roms/ipxe/src/util/parserom.pl b/roms/ipxe/src/util/parserom.pl
old mode 100644
new mode 100755
index cf9f7c69b8206e72c7a63c4a1c532f064a6ed96a..e278e6336e4dbaded98a26a72db1f9081b5c9fba
--- a/roms/ipxe/src/util/parserom.pl
+++ b/roms/ipxe/src/util/parserom.pl
@@ -1,4 +1,4 @@
-#!/usr/bin/perl -w
+#!/usr/bin/env perl
 #
 # Parse PCI_ROM and ISA_ROM entries from a source file on stdin and
 # output the relevant Makefile variable definitions to stdout
@@ -28,6 +28,7 @@ sub rom {
     $printed_family = 1;
   }
   print "\n";
+  return if ( $vendor && ( ( $vendor eq "ffff" ) || ( $device eq "ffff" ) ) );
   print "# NIC\t$image\t$ids\t$desc\n";
   print "DRIVER_$image = $driver_name\n";
   print "ROM_TYPE_$image = $type\n";
@@ -49,7 +50,6 @@ while ( <DRV> ) {
          \s*.*\s*		   # Driver data
        \)/x ) {
     ( my $vendor, my $device, my $image, my $desc ) = ( lc $1, lc $2, $3, $4 );
-    next if ( $vendor eq "ffff" ) || ( $device eq "ffff" );
     rom ( "pci", lc "${vendor}${device}", $desc, $vendor, $device );
     rom ( "pci", $image, $desc, $vendor, $device, 1 );
   } elsif ( /^\s*ISA_ROM\s*\(
diff --git a/roms/ipxe/src/util/romcheck.pl b/roms/ipxe/src/util/romcheck.pl
new file mode 100755
index 0000000000000000000000000000000000000000..f47bb07e875299bffe2ee181797f62bf413a6eb5
--- /dev/null
+++ b/roms/ipxe/src/util/romcheck.pl
@@ -0,0 +1,54 @@
+#!/usr/bin/perl -w
+
+use strict;
+use warnings;
+
+use constant DEVICES => "/proc/bus/pci/devices";
+
+open my $fh, DEVICES
+    or die "Could not open ".DEVICES.": $!";
+
+while ( ( my $line = <$fh> ) ) {
+
+  # Parse line from /proc/bus/pci/devices
+  chomp $line;
+  ( my $bus, my $devfn, my $vendor, my $device, my $irq, my $bars, my $lengths,
+    my $driver )
+      = ( $line =~ /^ ([0-9a-f]{2}) ([0-9a-f]{2}) \s+
+		      ([0-9a-f]{4}) ([0-9a-f]{4}) \s+ ([0-9a-f]+) \s+
+		      ((?:[0-9a-f]+\s+){7}) ((?:[0-9a-f]+\s+){7})
+		      (.+)?$/x )
+      or die "Invalid line \"".$line."\"\n";
+  ( $bus, $devfn, $vendor, $device, $irq ) =
+      map { hex ( $_ ) } ( $bus, $devfn, $vendor, $device, $irq );
+  my $dev = ( $devfn >> 3 );
+  my $fn = ( $devfn & 0x7 );
+  $bars = [ map { hex ( $_ ) } split ( /\s+/, $bars ) ];
+  $lengths = [ map { hex ( $_ ) } split ( /\s+/, $lengths ) ];
+
+  # Calculate expansion ROM BAR presence and length
+  my $rom_length = $lengths->[6];
+
+  # Look for a BAR that could support a .mrom
+  my $mrom_ok;
+  if ( $rom_length ) {
+    for ( my $bar = 0 ; $bar < 7 ; $bar++ ) {
+      # Skip I/O BARs
+      next if $bars->[$bar] & 0x01;
+      # Skip low half of 64-bit BARs
+      $bar++ if $bars->[$bar] & 0x04;
+      # Skip 64-bit BARs with high dword set
+      next if $bars->[$bar] >> 32;
+      # Skip BARs smaller than the expansion ROM BAR
+      next if $lengths->[$bar] < $rom_length;
+      # This BAR is usable!
+      $mrom_ok = 1;
+      last;
+    }
+  }
+
+  printf "%02x:%02x.%x (%04x:%04x)", $bus, $dev, $fn, $vendor, $device;
+  printf " supports a %dkB .rom", ( $rom_length / 1024 ) if $rom_length;
+  printf " or .mrom" if $mrom_ok;
+  printf "\n";
+}
diff --git a/roms/ipxe/src/util/zbin.c b/roms/ipxe/src/util/zbin.c
index f0df5ea0d7e2bbd2674f471e3633..3b7cf95b3df7491dc3c5ef78f087 100644
--- a/roms/ipxe/src/util/zbin.c
+++ b/roms/ipxe/src/util/zbin.c
@@ -143,7 +143,7 @@ static int alloc_output_file ( size_t max_len, struct output_file *output ) {
 			  max_len );
 		return -1;
 	}
-	memset ( output->buf, 0xff, sizeof ( output->buf ) );
+	memset ( output->buf, 0xff, max_len );
 	return 0;
 }
 
@@ -218,7 +218,8 @@ static int process_zinfo_pack ( struct input_file *input,
 	return 0;
 }
 
-static int process_zinfo_payl ( struct input_file *input,
+static int process_zinfo_payl ( struct input_file *input
+					__attribute__ (( unused )),
 				struct output_file *output,
 				union zinfo_record *zinfo ) {
 	struct zinfo_payload *payload = &zinfo->payload;
@@ -229,20 +230,22 @@ static int process_zinfo_payl ( struct input_file *input,
 	if ( DEBUG ) {
 		fprintf ( stderr, "PAYL at %#zx\n", output->hdr_len );
 	}
+	return 0;
 }
 
-static int process_zinfo_add ( struct input_file *input,
+static int process_zinfo_add ( struct input_file *input
+					__attribute__ (( unused )),
 			       struct output_file *output,
 			       size_t len,
-			       struct zinfo_add *add,
+			       struct zinfo_add *add, size_t offset,
 			       size_t datasize ) {
-	size_t offset = add->offset;
 	void *target;
 	signed long addend;
 	unsigned long size;
 	signed long val;
 	unsigned long mask;
 
+	offset += add->offset;
 	if ( ( offset + datasize ) > output->len ) {
 		fprintf ( stderr, "Add at %#zx outside output buffer\n",
 			  offset );
@@ -316,42 +319,90 @@ static int process_zinfo_addb ( struct input_file *input,
 				struct output_file *output,
 				union zinfo_record *zinfo ) {
 	return process_zinfo_add ( input, output, output->len,
-				   &zinfo->add, 1 );
+				   &zinfo->add, 0, 1 );
 }
 
 static int process_zinfo_addw ( struct input_file *input,
 				struct output_file *output,
 				union zinfo_record *zinfo ) {
 	return process_zinfo_add ( input, output, output->len,
-				   &zinfo->add, 2 );
+				   &zinfo->add, 0, 2 );
 }
 
 static int process_zinfo_addl ( struct input_file *input,
 				struct output_file *output,
 				union zinfo_record *zinfo ) {
 	return process_zinfo_add ( input, output, output->len,
-				   &zinfo->add, 4 );
+				   &zinfo->add, 0, 4 );
 }
 
 static int process_zinfo_adhb ( struct input_file *input,
 				struct output_file *output,
 				union zinfo_record *zinfo ) {
 	return process_zinfo_add ( input, output, output->hdr_len,
-				   &zinfo->add, 1 );
+				   &zinfo->add, 0, 1 );
 }
 
 static int process_zinfo_adhw ( struct input_file *input,
 				struct output_file *output,
 				union zinfo_record *zinfo ) {
 	return process_zinfo_add ( input, output, output->hdr_len,
-				   &zinfo->add, 2 );
+				   &zinfo->add, 0, 2 );
 }
 
 static int process_zinfo_adhl ( struct input_file *input,
 				struct output_file *output,
 				union zinfo_record *zinfo ) {
 	return process_zinfo_add ( input, output, output->hdr_len,
-				   &zinfo->add, 4 );
+				   &zinfo->add, 0, 4 );
+}
+
+static int process_zinfo_adpb ( struct input_file *input,
+				struct output_file *output,
+				union zinfo_record *zinfo ) {
+	return process_zinfo_add ( input, output,
+				   ( output->len - output->hdr_len ),
+				   &zinfo->add, 0, 1 );
+}
+
+static int process_zinfo_adpw ( struct input_file *input,
+				struct output_file *output,
+				union zinfo_record *zinfo ) {
+	return process_zinfo_add ( input, output,
+				   ( output->len - output->hdr_len ),
+				   &zinfo->add, 0, 2 );
+}
+
+static int process_zinfo_adpl ( struct input_file *input,
+				struct output_file *output,
+				union zinfo_record *zinfo ) {
+	return process_zinfo_add ( input, output,
+				   ( output->len - output->hdr_len ),
+				   &zinfo->add, 0, 4 );
+}
+
+static int process_zinfo_appb ( struct input_file *input,
+				struct output_file *output,
+				union zinfo_record *zinfo ) {
+	return process_zinfo_add ( input, output,
+				   ( output->len - output->hdr_len ),
+				   &zinfo->add, output->hdr_len, 1 );
+}
+
+static int process_zinfo_appw ( struct input_file *input,
+				struct output_file *output,
+				union zinfo_record *zinfo ) {
+	return process_zinfo_add ( input, output,
+				   ( output->len - output->hdr_len ),
+				   &zinfo->add, output->hdr_len, 2 );
+}
+
+static int process_zinfo_appl ( struct input_file *input,
+				struct output_file *output,
+				union zinfo_record *zinfo ) {
+	return process_zinfo_add ( input, output,
+				   ( output->len - output->hdr_len ),
+				   &zinfo->add, output->hdr_len, 4 );
 }
 
 struct zinfo_processor {
@@ -371,6 +422,12 @@ static struct zinfo_processor zinfo_processors[] = {
 	{ "ADHB", process_zinfo_adhb },
 	{ "ADHW", process_zinfo_adhw },
 	{ "ADHL", process_zinfo_adhl },
+	{ "ADPB", process_zinfo_adpb },
+	{ "ADPW", process_zinfo_adpw },
+	{ "ADPL", process_zinfo_adpl },
+	{ "APPB", process_zinfo_appb },
+	{ "APPW", process_zinfo_appw },
+	{ "APPL", process_zinfo_appl },
 };
 
 static int process_zinfo ( struct input_file *input,
